package javax.swing.text;

import java.awt.Shape;
import java.awt.Graphics;

public interface Highlighter
{
    public abstract void install(JTextComponent p0);
    
    public abstract void deinstall(JTextComponent p0);
    
    public abstract void paint(Graphics p0);
    
    public abstract Object addHighlight(int p0, int p1, Highlighter.HighlightPainter p2) throws BadLocationException;
    
    public abstract void removeHighlight(Object p0);
    
    public abstract void removeAllHighlights();
    
    public abstract void changeHighlight(Object p0, int p1, int p2) throws BadLocationException;
    
    public abstract Highlighter.Highlight[] getHighlights();
    
    public interface Highlight
    {
        public abstract int getStartOffset();
        
        public abstract int getEndOffset();
        
        public abstract Highlighter.HighlightPainter getPainter();
    }
    
    public interface HighlightPainter
    {
        public abstract void paint(Graphics p0, int p1, int p2, Shape p3, JTextComponent p4);
    }
}
